(  EATDRINK.MUF     by Gyroplast  07/31/98                                    )
(                                                                             )
(  This program allows the user to eat or drink objects!                      )
(                                                                             )
(  Works in coordination with the MAKEMIX.MUF, but MAY be used on its own.    )
(  {Although this is not recommended!}                                        )
(                                                                             )
(  To make it possible to eat an object, @set <object>=_edible:yes            )
(  To make it possible to drink an object, @set <object>=_drinkable:yes       )
(                                                                             )
(  You can also customize the eat and drink messages.                         )
(  %n will be substituted with the object's name.                             )
(                                                                             )
(  All you've got to do is to add some properties to the room.                )
(  {Yes, the messages depend on the room you're in!}                          )
(                                                                             )
(  The properties are:                                                        )
(     _eat/succ:<message shown to you when eating>                            )
(     _eat/osucc:<msg shown to others when eating>                            )
(     _drink/succ:<message shown to you when you drink something>             )
(     _drink/osucc:<msg shown to others when drinking>                        )
(                                                                             )
(  NOTE: Your name is prepended to the osucc messages.                        )
(                                                                             )
(  Have phun!                                                                 )
(                                                                             )
(                                                                             )
(** Change this to the dbref of the room to where the consumed food is sent **)
$def garbage #746
lvar succstr
lvar osuccstr
lvar dsuccstr
lvar dosuccstr
: getmesgs
  me @ location
  dup "_eat/succ" getpropstr succstr !
  dup "_eat/osucc" getpropstr osuccstr !
  dup "_drink/succ" getpropstr dsuccstr !
  "_drink/osucc" getpropstr dosuccstr !
  succstr @ not if
   "You eat a bit of %n, savouring it's wonderful flavour!" succstr !
  then
  osuccstr @ not if
   "eats a bit of %n, savouring it's wonderful flavour!" osuccstr !
  then
  dsuccstr @ not if
   "You drink a bit of %n, savouring it's wonderful flavour!" dsuccstr !
  then
  dosuccstr @ not if
   "drinks a bit of %n, savouring it's wonderful flavour!" dosuccstr !
  then
;
: eatme
  dup name succstr @ swap "%n" subst .tell
  dup name osuccstr @ swap "%n" subst me @ name " " strcat swap strcat .otell
  dup "_eat/bitesleft" getpropstr atoi
  dup 0 = over 3 > or if pop 3 then
  1 -
  dup 2 = if "There's still some left." .tell then
  dup 1 = if "There's still a little left." .tell then
  dup 0 = if
   "There's nothing left." .tell me @ name " finishes it."
   strcat .otell swap dup 
   getlink dup #-1 dbcmp if
    pop garbage
   then   
   moveto
  then
  dup 0 > if over swap "_eat/bitesleft" swap intostr 0 addprop then
;
: drinkme
  dup name dsuccstr @ swap "%n" subst .tell
  dup name dosuccstr @ swap "%n" subst me @ name " " strcat swap strcat .otell
  dup "_eat/bitesleft" getpropstr atoi
  dup 0 = over 3 > or if pop 3 then
  1 -
  dup 2 = if "There's still some left." .tell then
  dup 1 = if "There's still a little left." .tell then
  dup 0 = if
   "There's nothing left." .tell me @ name " finishes it."
   strcat .otell swap dup 
   getlink dup #-1 dbcmp if
    pop garbage
   then   
   moveto
  then  
  dup 0 > if over swap "_eat/bitesleft" swap intostr 0 addprop then
;
: main
  dup not if "You should tell me what you want to consume..." .tell exit then
  match
  dup #-1 dbcmp if "I don't see that here!" .tell exit then
  dup #-2 dbcmp if "I don't know which one you mean!" .tell exit then
  dup player? if "You cannot eat a player, sicko! Not here!" .tell exit then
  dup program? if
   "Yeah, I would like to know how a PROGRAM tastes, too..." .tell exit
  then
  dup room? if
   "You begin to nibble on the corner of the room.  Soon, you become bloated with woodchips and give up."
   .tell exit
  then
  dup exit? if
   "I could bet you're the only one that would like to munch on an exit..."
   .tell exit
  then
  getmesgs
  command @ "eat" stringcmp not if 
   dup "_edible" getpropstr "yes" stringcmp not if 
    eatme exit else "This is not edible!" .tell
   then
  then
  command @ "drink" stringcmp not if
   dup "_drinkable" getpropstr "yes" stringcmp not if
    drinkme exit else "This is not drinkable!" .tell
   then
  then
;

