(  WhoAll.MUF     by Gyroplast  08/04/98    v1.0
  This program lists and counts ALL players, with the  
  db#, creation date, and last connection date shown.  
  If a name is given as a parameter, it shows the stats for only THAT name.  
  Simply link an action and run it.  
  HAVE PHUN!  
)
lvar count
lvar count2
lvar changes
lvar dec
$def dellist TRIG "temp" remove_prop TRIG "tmp" remove_prop
: padstr
  swap "                                              " strcat
  swap
  strcut
  pop
;
: getplayerinfo  ( d -- s )
  dup player? not if pop "This is not a valid player name!" exit then
  dup name
  15 padstr
  over
  intostr "#" swap strcat ", " strcat strcat
  over
  timestamps
  not if
    pop pop pop
    "Last on: NEVER CONNECTED  "
  else
    swap pop swap pop
    "Last on: %a, %x  "
    swap timefmt
  then
  strcat
  swap
  timestamps
  pop pop pop
  "Created: %a, %x"
  swap
  timefmt
  strcat
;
: showlist
  1
  BEGIN
    TRIG over intostr
    "temp/" swap strcat getpropstr
    dup while 
      atoi dbref
      getplayerinfo
      .tell
      1 +
  REPEAT
  pop
;
: readplayers
  "Extracting players from database..." .tell
  0 dup count !
  BEGIN
  1 +
  dup dbtop int >= if pop break then
  dup
  dbref
  dup player? not if
    pop
  else  
    count @ 1 + count !
    dup name (i d s)
    TRIG swap "temp/" count @ intostr strcat "/name" strcat swap 0 ADDPROP
    dup
    timestamps
    not if
      pop pop pop  
      TRIG "temp/" count @ intostr strcat "/lo" strcat "1" 0 ADDPROP
    else
      swap pop swap pop
      TRIG swap intostr "temp/" count @ intostr strcat "/lo" strcat swap 0 ADDPROP
    then
    dup
    timestamps
    pop pop pop
    TRIG swap intostr "temp/" count @ intostr strcat "/cd" strcat swap 0 ADDPROP
    TRIG swap intostr "temp/" count @ intostr strcat swap 0 ADDPROP
  then
  REPEAT
; 
: show
  showlist
  "Program done." .tell
  "Counted " count @ intostr strcat " players." strcat .tell
  dellist
;
: dbrefsort
  readplayers
  "Sorting by dbref..." .tell
  show
;
: xchng  ( i i -- )
  TRIG over "temp/" swap intostr strcat "/cd" strcat getpropstr
  TRIG swap "tmp/cd" swap 0 ADDPROP
  TRIG over "temp/" swap intostr strcat "/lo" strcat getpropstr
  TRIG swap "tmp/lo" swap 0 ADDPROP
  
  TRIG over "temp/" swap intostr strcat "/name" strcat getpropstr
  TRIG swap "tmp/name" swap 0 ADDPROP
  TRIG over "temp/" swap intostr strcat getpropstr
  TRIG swap "tmp/db" swap 0 ADDPROP
  "temp/" swap intostr strcat swap
  over over
  TRIG swap "temp/" swap intostr strcat "/cd" strcat getpropstr
  swap "/cd" strcat TRIG swap rot 0 ADDPROP
  over over
  TRIG swap "temp/" swap intostr strcat "/lo" strcat getpropstr
  swap "/lo" strcat TRIG swap rot 0 ADDPROP
  over over
  TRIG swap "temp/" swap intostr strcat "/name" strcat getpropstr
  swap "/name" strcat TRIG swap rot 0 ADDPROP
  over over
  TRIG swap "temp/" swap intostr strcat getpropstr
  swap TRIG swap rot 0 ADDPROP
  intostr "temp/" swap strcat swap pop
  TRIG over "/cd" strcat TRIG "tmp/cd" getpropstr 0 ADDPROP
  TRIG over "/lo" strcat TRIG "tmp/lo" getpropstr 0 ADDPROP
  TRIG over "/name" strcat TRIG "tmp/name" getpropstr 0 ADDPROP
  TRIG swap TRIG "tmp/db" getpropstr 0 ADDPROP
;
: createdsort ( i -- )   ( mode --  )
  dec !
  readplayers
  "Sorting by creation date..." .tell
  BEGIN
   1 count2 !
   0 changes !
   BEGIN
    TRIG "temp/" count2 @ intostr strcat "/cd" strcat getpropstr atoi
    TRIG "temp/" count2 @ 1 + dup count2 ! intostr strcat "/cd" strcat
    getpropstr atoi
    dup not if pop pop break then
    dec @ if < else > then
    if
     count2 @ dup 1 - xchng
     changes @ 1 + changes ! 
    then
   REPEAT
   changes @ while
  REPEAT
  show
;
: lastonsort ( i -- )   ( mode --  )
  dec !
  readplayers
  "Sorting by laston date..." .tell
  BEGIN
   1 count2 !
   0 changes !
   BEGIN
    TRIG "temp/" count2 @ intostr strcat "/lo" strcat getpropstr atoi
    TRIG "temp/" count2 @ 1 + dup count2 ! intostr strcat "/lo" strcat
    getpropstr atoi
    dup not if pop pop break then
    dec @ if < else > then
    if
     count2 @ dup 1 - xchng
     changes @ 1 + changes ! 
    then
   REPEAT
   changes @ while
  REPEAT
  show
;
: namesort ( i -- )   ( mode --  )
  dec !
  readplayers
  "Sorting by name..." .tell
  BEGIN
   1 count2 !
   0 changes !
   BEGIN
    TRIG "temp/" count2 @ intostr strcat "/name" strcat getpropstr
    TRIG "temp/" count2 @ 1 + dup count2 ! intostr strcat "/name" strcat
    getpropstr
    dup not if pop pop break then
    stringcmp 0
    dec @ if < else > then
    if
     count2 @ dup 1 - xchng
     changes @ 1 + changes ! 
    then
   REPEAT
   changes @ while
  REPEAT
  show
;
: help
  " " .tell
  "  WHOALL  --  Help" .tell
  " " .tell
  "    Lists all players on the muck, sorted by certain categories." .tell
  " " .tell
  "    PARAMETERS: " .tell
  "      #dbref <mode>   : Lists all players sorted by dbref" .tell
  "      #created <mode> : Sorts by creation date" .tell
  "      #laston <mode>  : Sorts by date of last connection" .tell
  "      #name <mode>    : Sorts by name" .tell
  "      #help           : Umm.. this @toads all players!" .tell
  " " .tell
  "      <mode> may be either 0 to sort the list in ascending," .tell
  "      or any other number to sort it in descending order." .tell
  " " .tell
  "      Commands may be abbreviated." .tell
  " " .tell
;
: main
  BACKGROUND
  me @ "W" flag? not me @ #4373 dbcmp not and if
    "Only wizzes may use this program." .tell exit then
  STRIP
  dup not if pop help exit then
  dup "#" instring not if .pmatch getplayerinfo .tell exit then
  dup "#db" stringpfx 1 = if pop dbrefsort exit then
  dup "#cr" stringpfx 1 = if 
   dup " " instr dup not if
    pop pop 0
   else
    strcut swap pop STRIP atoi
   then
   createdsort exit
  then
  dup "#la" stringpfx 1 = if 
   dup " " instr dup not if
    pop pop 0
   else
    strcut swap pop STRIP atoi
   then
   lastonsort exit
  then
  dup "#na" stringpfx 1 = if 
   dup " " instr dup not if
    pop pop 0
   else
    strcut swap pop STRIP atoi
   then
   namesort exit
  then
  help
;

