(
  gmedit.muf     by Gyroplast  12/05/98     v1.11 
  
  Easily add and edit morphs for guesties using the GuestTRaM.muf
 
  SETUP:                                                                 
  ------                                                                 
     1. Change the $defs below to reflect your muck's needs
     2. Link an action to this program. Preferably a global one.
 
  Have phun!
 
  NOTE: This program alone is rather pointless. To actually make sense,
        you need GuestTRaM.muf as well.
 
  *** check http://www.gyroplast.com for this and many other programs! ***
  *** This program is distributed under the GPL. Porting and mods      ***
  *** are explicitly allowed as long as this header stays intact, and  ***
  *** the result of any modification is distributed under the GPL.     ***
  *** For a detailed description of the DOs and DONTs, read the GPL at ***
  *** http://www.gyroplast.com/help/gpl.txt   --Thank you--            ***
 
)
(** Change this to the db# of the morph-db object **)
$def database #4099  ( dbref# of the object keeping the morph data; )
                     ( This MUST be the same as in GuestTRaM.muf!   )
$def lsdbref #27     ( dbref# of your 'lsedit' program )
$def pagedb #23      ( dbref# of your 'page' program )
 
$def version "v1.11"
$def title "GMEdit  " version strcat "   by Gyroplast" strcat
LVAR say
LVAR osay
LVAR scent
LVAR sex
LVAR species
LVAR count
LVAR temp
LVAR source
LVAR reason
LVAR mno
 
: pad   ( s i --  )  ( string newstringlength --  )
  swap "                                               " strcat swap strcut pop
;
: showdesc ( s --  )  ( show desc of morph# --  )
  0
  BEGIN
   1 +
   over database swap "@morph/" swap strcat "/desc#" strcat getpropstr atoi over swap <= while
   over database swap "@morph/" swap strcat "/desc#/" strcat
   3 pick intostr strcat
   getpropstr .tell
  REPEAT
  pop pop
;
: list
  " " .tell
  " #  | Species             | Gender    | Creator         | A | D | N" .tell
  "----+---------------------+-----------+-----------------+---+---+----" .tell
  0 " "
  BEGIN
   swap 1 + swap
   over database "_morphcount" getpropstr atoi <= while
   over intostr strcat 4 pad "| " strcat
   over database swap "@morph/" swap intostr strcat "/species" strcat
   getpropstr 20 pad "| " strcat strcat
   over database swap "@morph/" swap intostr strcat "/sex" strcat
   getpropstr 10 pad "| " strcat strcat
   over database swap "@morph/" swap intostr strcat "/creator" strcat
   getpropstr 16 pad "| " strcat strcat
   over database swap "@morph/" swap intostr strcat "/deny" strcat getpropstr
   "yes" stringcmp not if
    "  | X |" strcat
   else
    over database swap "@morph/" swap intostr strcat "/reviewed" strcat getpropstr
    not if
    "  |   | X" strcat
    else
    "X |   |" strcat
    then 
   then
   .tell
   " "
  REPEAT
  pop pop
;
: listmorphs
  BEGIN
   list
   " " .tell
   "--- To show the desc of a morph, type its #, to leave type 'q' ---" .tell
   READ STRIP
   dup 1 strcut pop "q" stringcmp not if pop break then
   atoi dup
   database "_morphcount" getpropstr atoi >
   over 1 < OR if pop continue else intostr then
   " " .tell
   "Description of morph #" over strcat " :" strcat .tell
   showdesc
   " " .tell
   "--- Type anything to get back to the list ---" .tell
   READ pop
  REPEAT
;
: allowmorph   ( s --  )   ( number of morph --  )
  temp !
  "Processing.." .tell
  database "@morph/" temp @ strcat "/reviewed" strcat me @ name 0 ADDPROP
  "." .tell
  database "@morph/" temp @ strcat "/deny" strcat remove_prop
  "." .tell
  "DONE" .tell
  database "@morph/" temp @ strcat "/creator" strcat getpropstr source !
   me @
   "#mail " source @ strcat
   "=The guest morph you added has been processed! Thanx for your help! (Automatic page)" strcat
   pagedb call
  "Morph successfully processed." .tell
;
: denymorph   ( s --  )   ( number of morph --  )
  temp !
  "Processing.." .tell
  database "@morph/" temp @ strcat "/reviewed" strcat
  "DENIED by " me @ name strcat "! Reason: " strcat reason @ strcat 0 ADDPROP
  "." .tell
  database "@morph/" temp @ strcat "/deny" strcat "yes" 0 ADDPROP
  "." .tell
  "DONE" .tell
  me @ database "@morph/" temp @ strcat "/creator" strcat getpropstr
  source !
   me @
   "#mail " source @ strcat
   "=The guest morph you added has been denied by " strcat
   me @ name strcat 
   "! Reason: " strcat reason @ strcat 
   "(Automatic page)" strcat
   pagedb call
   "Morph denied. It won't be assigned to a guest." .tell
;
: cppropdesc
  "Property based description.." .tell
  me @ desc
  "." .tell
  database swap "@morph/" temp @ strcat "/desc#/1" strcat swap 0 ADDPROP
  "." .tell
  database "@morph/" temp @ strcat "/desc#" strcat "1" 0 ADDPROP
  "DONE" .tell
;
: cpmpidesc
  "Description list 'REDESC'.." .tell
  0 count !
  BEGIN
   count @ 1 + dup count !
   me @ "redesc#" getpropstr atoi > not while
   me @ "redesc#/" count @ intostr strcat getpropstr
   database swap "@morph/" temp @ strcat "/desc#/" strcat
   count @ intostr strcat swap 0 ADDPROP
   "." .tell
  REPEAT
  database "@morph/" temp @ strcat "/desc#" strcat
  me @ "redesc#" getpropstr
  0 ADDPROP
  "." .tell
  "DONE" .tell
;
: cplistdesc
  BEGIN
   " " .tell
   "What's the name of the list you want to transfer? ('.' to abort)" .tell
   READ STRIP
   dup "." stringcmp not if pop 1 exit then
   dup not if pop continue then
   source !
   "List contents:" .tell
   0
   BEGIN
    1 +
    dup me @ source @ "#" strcat getpropstr atoi <= while
    me @ over source @ "#/" strcat swap intostr strcat getpropstr .tell
   REPEAT
   pop
   " " .tell
   "Are you sure you want to transfer this list? (y/n)" .tell
   READ STRIP
   1 strcut pop
   "y" stringcmp if continue else break then
  REPEAT
  "Transferring:" .tell
  "Description list '" source @ strcat "'.." strcat .tell
  0 count !
  BEGIN
   count @ 1 + dup count !
   me @ source @ "#" strcat getpropstr atoi > not while
   me @ source @ "#/" strcat count @ intostr strcat getpropstr
   database swap "@morph/" temp @ strcat "/desc#/" strcat
   count @ intostr strcat swap 0 ADDPROP
   "." .tell
  REPEAT
  database "@morph/" temp @ strcat "/desc#" strcat
  me @ source @ "#" strcat getpropstr
  0 ADDPROP
  "." .tell
  "DONE" .tell
  0
;
: transfer
  database "_morphcount" getpropstr atoi 1 + intostr temp !
  " " .tell
  "Your propdesc is:" .tell
  me @ desc .tell
  " " .tell
  "Your default MPI desc (redesc) is:" .tell
  0
  BEGIN
   1 +
   dup me @ "redesc#" getpropstr atoi <= while
   me @ over "redesc#/" swap intostr strcat getpropstr .tell
  REPEAT
  pop
  BEGIN
   " " .tell
   "Do you want to copy your <P>ropdesc, your default <M>PI desc, or another <L>ist? ('.' to abort)" .tell
   READ STRIP
   1 strcut pop
   dup "." stringcmp not if pop exit then
   dup "p" stringcmp not if pop "Transferring:" .tell cppropdesc break then
   dup "m" stringcmp not if pop "Transferring:" .tell cpmpidesc break then
   "l" stringcmp not if cplistdesc not if break else exit then then
   "Invalid option, try again." .tell
  REPEAT
  "SAY/OSAY verbs.." .tell
  me @ "_say/def/say" getpropstr
  "." .tell
  database swap "@morph/" temp @ strcat "/say" strcat swap 0 ADDPROP
  "." .tell
  me @ "_say/def/osay" getpropstr
  "." .tell
  database swap "@morph/" temp @ strcat "/osay" strcat swap 0 ADDPROP
  "." .tell
  "DONE" .tell
 
  "Scent.." .tell
  me @ "_scent" getpropstr
  "." .tell
  database swap "@morph/" temp @ strcat "/scent" strcat swap 0 ADDPROP
  "." .tell
  "DONE" .tell
 
  "Species.." .tell
  me @ "species" getpropstr
  "." .tell
  database swap "@morph/" temp @ strcat "/species" strcat swap 0 ADDPROP
  "." .tell
  "DONE" .tell
 
  "Gender.." .tell
  me @ "gender" getpropstr
  dup not if pop me @ "sex" getpropstr then
  "." .tell
  database swap "@morph/" temp @ strcat "/sex" strcat swap 1 ADDPROP
  "." .tell
  "DONE" .tell
  
  database "@morph/" temp @ strcat "/creator" strcat me @ name 1 ADDPROP
  database "_morphcount"
  over over getpropstr atoi 1 + intostr
  0 ADDPROP
  "Transfer completed!" .tell
  me @ "W" flag? not if
   "You'll be notified when your morph is reviewed." .tell
  else
   "Wizard status acknowledged. Adding morph now..." .tell
   temp @ allowmorph
  then
;
: details  ( s --  )   ( morph# --  )
   "---------------- MORPH #" over strcat " ---------------------" strcat .tell
   "Description :" .tell
   dup showdesc
   " " .tell
   "SAY verb  : " database "@morph/" 4 pick strcat "/say" strcat getpropstr strcat .tell
   "OSAY verb : " database "@morph/" 4 pick strcat "/osay" strcat getpropstr strcat .tell
   "Gender    : " database "@morph/" 4 pick strcat "/sex" strcat getpropstr strcat .tell
   "Scent     : " database "@morph/" 4 pick strcat "/scent" strcat getpropstr strcat .tell
   "Species   : " database "@morph/" 4 pick strcat "/species" strcat getpropstr strcat .tell
   "Creator   : " database "@morph/" 4 pick strcat "/creator" strcat getpropstr strcat .tell
   "Reviewed  : " database "@morph/" 4 pick strcat "/reviewed" strcat getpropstr 
   dup not if pop "NOT REVIEWED" then   
   strcat .tell
   pop
;
: showdetails
  BEGIN
   list
   " " .tell
   "--- Type # of morph for details, or 'q' to leave ---" .tell
   READ STRIP
   dup 1 strcut pop "q" stringcmp not if pop break then
   atoi dup
   database "_morphcount" getpropstr atoi >
   over 1 < OR if pop continue else intostr then
   " " .tell
   details
   " " .tell
   "--- Type anything to get back to the list ---" .tell
   READ pop
  REPEAT
;
: allowdeny
  BEGIN
   list
   " " .tell
   "--- Type # of morph, or 'q' to leave ---" .tell
   READ STRIP
   dup 1 strcut pop "q" stringcmp not if pop break then
   atoi dup
   database "_morphcount" getpropstr atoi >
   over 1 < OR if pop continue else intostr then
   " " .tell
   "Do you want to <d>eny or <a>llow the morph?" .tell
   READ STRIP
   dup not if pop continue then
   1 strcut pop
   "a" stringcmp not if 
    " " .tell
    dup details
    " " .tell
    "Really allow this morph and add it to the list of potential guest chars? (y/n)" .tell
    READ STRIP
    dup not if pop pop continue then
    1 strcut pop
    "n" stringcmp not if pop continue then
    allowmorph
   else
    " " .tell
    dup details
    " " .tell
    "Really deny this morph? (y/n)" .tell
    READ STRIP
    dup not if pop pop continue then
    1 strcut pop
    "n" stringcmp not if pop continue then
    "Enter a reason:" .tell
    READ reason !
    denymorph
   then
  REPEAT
;
: delete   ( s --  )  ( # to delete --  )
  database "_morphcount"
  over over getpropstr dup temp ! atoi 1 - intostr 0 ADDPROP
  database "@morph/" 3 pick strcat remove_prop
  database "@morph/" 3 pick strcat "/say" strcat
  database "@morph/" temp @ strcat "/say" strcat getpropstr 0 ADDPROP
  database "@morph/" 3 pick strcat "/osay" strcat
  database "@morph/" temp @ strcat "/osay" strcat getpropstr 0 ADDPROP
  database "@morph/" 3 pick strcat "/sex" strcat
  database "@morph/" temp @ strcat "/sex" strcat getpropstr 0 ADDPROP
  database "@morph/" 3 pick strcat "/scent" strcat
  database "@morph/" temp @ strcat "/scent" strcat getpropstr 0 ADDPROP
  database "@morph/" 3 pick strcat "/species" strcat
  database "@morph/" temp @ strcat "/species" strcat getpropstr 0 ADDPROP
  database "@morph/" 3 pick strcat "/deny" strcat
  database "@morph/" temp @ strcat "/deny" strcat getpropstr 0 ADDPROP
  database "@morph/" 3 pick strcat "/reviewed" strcat
  database "@morph/" temp @ strcat "/reviewed" strcat getpropstr 0 ADDPROP
  database "@morph/" 3 pick strcat "/creator" strcat
  database "@morph/" temp @ strcat "/creator" strcat getpropstr 0 ADDPROP
  0
  BEGIN
   1 +
   database "@morph/" temp @ strcat "/desc#" strcat getpropstr atoi
   over swap <= while
   database "@morph/" temp @ strcat "/desc#/" strcat 3 pick intostr strcat getpropstr
   database "@morph/" 5 pick strcat "/desc#/" strcat 4 pick intostr strcat 3 rotate 0 ADDPROP
  REPEAT
  pop
  database "@morph/" temp @ strcat "/desc#" strcat getpropstr
  database "@morph/" 4 rotate strcat "/desc#" strcat 3 rotate 0 ADDPROP
  database "@morph/" temp @ strcat remove_prop
  "Morph deleted." .tell
;
: delmorph
  BEGIN
   list
   " " .tell
   "--- Type # of morph, or 'q' to leave ---" .tell
   READ STRIP
   dup 1 strcut pop "q" stringcmp not if pop break then
   atoi dup
   database "_morphcount" getpropstr atoi >
   over 1 < OR if pop continue else intostr then
   " " .tell
   dup details
   " " .tell
   "Do you really want to DELETE this morph? (y/n)" .tell
   "Warning! No recovery possible, ALL data will be lost!" .tell
   READ STRIP
   dup not if pop pop continue then
   1 strcut pop
   "n" stringcmp not if pop continue then
   delete
  REPEAT  
;
: wizopt
  BEGIN
   " " .tell
   title .tell
   "---------------------------------------------" title strlen strcut pop .tell
   " " .tell
   "  <1> Allow/deny morphs" .tell
   "  <2> Show morph details" .tell
   "  <3> Delete morphs" .tell
   " " .tell
   "  <Q> BACK" .tell
   " " .tell 
   READ STRIP
   dup not if pop "Invalid option." .tell continue else 1 strcut pop then
   dup "1" stringcmp not if pop allowdeny continue then
   dup "2" stringcmp not if pop showdetails continue then
   dup "3" stringcmp not if pop delmorph continue then
   dup "Q" stringcmp not if pop break then
  REPEAT
  " " .tell
  " " .tell
;
: newmorph
  database "_morphcount"
  over over getpropstr dup temp ! atoi 1 + intostr dup mno ! 0 ADDPROP
  "You'll be asked for the following:" .tell
  "          o Description" .tell
  "          o SAY/OSAY verb" .tell
  "          o Scent" .tell
  "          o Gender" .tell
  "          o Species" .tell
  " " .tell
  "Make sure you have all these information at hand." .tell
  "To abort, type '.' at any time. Type anthing to continue." .tell
  READ STRIP
  "." strcmp not if "Aborted." .tell mno @ delete exit then
  " " .tell
  "Enter a description!" .tell
  " " .tell
  database intostr "=@morph/" mno @ strcat "/desc" strcat strcat lsdbref CALL 
  " " .tell
  "What do you see when you're talking? (Don't append a comma!)" .tell
  "EX: bark" .tell
  READ STRIP
  dup "." strcmp not if pop "Aborted." .tell mno @ delete exit then
  database swap "@morph/" mno @ strcat "/say" strcat swap 0 ADDPROP
  " " .tell
  "What do others see when you're talking? (Don't append a comma!)" .tell
  "EX: barks" .tell
  READ STRIP
  dup "." strcmp not if pop "Aborted." .tell mno @ delete exit then
  database swap "@morph/" mno @ strcat "/osay" strcat swap 0 ADDPROP
  " " .tell
  "Whats the gender?" .tell
  "EX: female" .tell
  READ STRIP
  dup "." strcmp not if pop "Aborted." .tell mno @ delete exit then
  database swap "@morph/" mno @ strcat "/sex" strcat swap 0 ADDPROP
  " " .tell
  "And the species?" .tell
  "EX: squirrel" .tell
  READ STRIP
  dup "." strcmp not if pop "Aborted." .tell mno @ delete exit then
  database swap "@morph/" mno @ strcat "/species" strcat swap 0 ADDPROP
  " " .tell
  "Okay.. now we need the scent, and we're done!" .tell
  "EX: Smells like a fox." .tell
  READ STRIP
  dup "." strcmp not if pop "Aborted." .tell mno @ delete exit then
  database swap "@morph/" mno @ strcat "/scent" strcat swap 0 ADDPROP
  " " .tell
  me @ name
  database swap "@morph/" mno @ strcat "/creator" strcat swap 0 ADDPROP
  "The morph has been successfully created!" .tell
  "Thanks for your help!" .tell
  me @ "W" flag? not if
   "You'll be notified when your morph is reviewed." .tell
  else
   "Wizard status acknowledged. Adding morph now..." .tell
   mno @ allowmorph
  then
;
: main
  pop
  BEGIN
   " " .tell
   title .tell
   "---------------------------------------------" title strlen strcut pop .tell
   " " .tell
   "  <1> Create new morph from scratch" .tell 
   "  <2> Transfer data from your character to the morph database" .tell
   "  <3> List all morphs" .tell
   "  <4> Additional Wizard options" .tell
   " " .tell
   "  <Q> QUIT" .tell
   " " .tell 
   READ STRIP
   dup not if pop "Invalid option." .tell continue else 1 strcut pop then
   dup "1" stringcmp not if pop newmorph continue then
   dup "2" stringcmp not if pop transfer continue then
   dup "3" stringcmp not if pop listmorphs continue then
   dup "4" stringcmp not if
    pop me @ "W" flag? not if
     "These options are for wizbitted players only." .tell
     " " .tell
    else
     wizopt
    then 
    continue
   then
   dup "Q" stringcmp not if pop break then
   pop "Invalid option." .tell
  REPEAT
  "Program terminated." .tell
;

