( orbit.muf     by Gyroplast   05/07/99
  
  This programs moves objects and players through an 'orbit' of
  rooms in preset intervals.
 
  SETUP:
    1. Create and action an link it to this program.
    2. Run the action.
    3. Follow the instructions.
    4. Have phun!
  Permission to port is hereby granted. Make only necessary changes
  to the code, and report any bugs you find to gyroplast@wtal.de
  and the owner of this program.
)
 
$def version "v1.0 Beta"
$def header "Orbit " version " by Gyroplast (gyroplast@wtal.de)" strcat strcat
$def .uline "------------------------------------------------------------------------------" swap strlen strcut pop .tell
$def cleanstack begin dup while 1 - swap pop repeat pop
LVAR sourceroom
LVAR destroom
 
: GetRoomList (  -- s)
  loc @ "_orbit/roomlist" getpropstr   
;
 
: GetDelay (  -- i)
  loc @ "_orbit/delay" getpropstr atoi
  GetRoomList
  " " explode
  dup dup 2 + -1 * rotate cleanstack
  /
;
 
: isrunning? (  -- b)
  loc @ "_orbit/started?" getpropstr
;
 
: anyoneleft?  (  -- b)
  GetRoomList
  " " explode
  BEGIN
    dup while
    1 - swap atoi dbref contents
    BEGIN
      dup #-1 dbcmp not while
      dup player? over thing? or if
       pop cleanstack 1 exit
      then
      next 
    REPEAT
    pop
  REPEAT
  pop 0
;
 
: moved? ( d -- b )
  "_orbit/moved?" getpropstr
;
 
: ShowMessages ( d d --  )
  over name " comes in." strcat #-1 swap notify_except
  dup location swap name " flies away." strcat #-1 swap notify_except
;
 
: DoMove ( d d --  )
  over over ShowMessages
  over "_orbit/moved?" "yup" 1 addprop
  moveto
;
 
: ResetMove (  --  )
  GetRoomList
  " " explode
  BEGIN
    dup while
    1 - swap atoi dbref contents
    BEGIN
      dup #-1 dbcmp not while
      dup player? over thing? or if
       dup "_orbit/moved?" remove_prop
      then
      next
    REPEAT
    pop
  REPEAT
  pop
;
 
: MoveAll (  --  )
  GetRoomList
  " " explode
  BEGIN
    dup while
    1 - swap atoi dbref contents
    BEGIN
      dup #-1 dbcmp not while
      dup player? over thing? or over moved? not and if
       over not if
        GetRoomList
        " " explode
        1 - swap over 2 + -1 * rotate cleanstack
       else 
        3 pick
       then
       atoi dbref over swap DoMove
      then
      next
    REPEAT
    pop 
  REPEAT
  pop
  ResetMove
;
 
: SetRunning
  GetRoomList
  " " explode
  BEGIN
    dup while
    1 - swap atoi dbref
    "_orbit/started?" "yes" 1 addprop
  REPEAT
  pop    
;
 
: ClearRunning
  GetRoomList
  " " explode
  BEGIN
    dup while
    1 - swap atoi dbref
    "_orbit/started?" remove_prop
  REPEAT
  pop
;
 
: main
  dup "#reset" stringcmp not if pop ClearRunning exit then
  dup "Arrive" strcmp not isrunning? and if pop exit then
  dup "Arrive" strcmp not isrunning? not and if
   pop SetRunning
   BEGIN
     GetDelay sleep
     isrunning? anyoneleft? and if
      MoveAll
     else
      ClearRunning break
     then
   REPEAT
  then
;

