(
   BANSWEEP.MUF     by Gyroplast  12/23/98    v1.0
 
   Allows the owner of a room to sweep pesky furs.
   May authorize others to do the same.
 
   INSTRUCTIONS:
     Just link an action to the program and run #setup.
 
   Known flaws:
     Messing around with the properties
     may result in an endless loop or other
     'undocumented features'.
     Don't say I didn't warn you.
 
  Have phun!
)
( These are the default messages )
$def succdef "You kick %n into next week!"
$def osuccdef "kicks %n into next week!"
$def victimdef "kicks you into next week!"
LVAR ref
LVAR temp
LVAR ref2
LVAR temp2
(
  Errorcodes:
    #-1 : Proplist empty
    #-2 : Last dbref in list
    #-3 : Passed dbref not found
)
: stripmid ( s -- s' )
  BEGIN
   dup "  " instr while
   " " "  " SUBST    
  REPEAT
;
: nextref    ( d s d -- d )   ( object prop ref -- nextref )
  ref !
  getpropstr
  dup not if pop #-1 exit then
  " " explode
  BEGIN
   1 - swap
   atoi dbref
   ref @ dbcmp
   if
    dup not if pop #-2 exit then
    1 - swap
    atoi dbref ref ! break
   else
    dup not if pop #-3 exit then
   then
  REPEAT
  BEGIN
   dup while
   1 - swap pop
  REPEAT
  pop
  ref @
;
: getfirstref  ( s -- d )  ( refliststring -- dbref )
  " " explode
  1 -
  swap
  atoi dbref ref !
  BEGIN
   dup while
   1 - swap pop
  REPEAT
  pop ref @
;
: delref ( d s d --  ) ( object prop dbref --  )
  ref !
  "" temp !
  over over
  getpropstr
  " " explode
  BEGIN
    dup not if pop break exit then
    1 -
    swap STRIP
    dup atoi dbref ref @ dbcmp
    if
     pop
    else
     temp @ dup not 
     if
      pop "" 
     then
     swap " " swap strcat strcat temp !
    then
  REPEAT
  temp @ dup not if pop remove_prop else STRIP 0 ADDPROP then
;
: kick ( d --  )  (playerdbref -- )
  dup loc @ "_swpsucc" getpropstr pronoun_sub .tell
  dup loc @ "_swpvictim" getpropstr me @ name " " strcat swap strcat notify
  dup loc @ "_swpdest" getpropstr atoi dbref moveto
  loc @ "_swposucc" getpropstr me @ name " " strcat swap strcat
  pronoun_sub .otell
;
: list-sweepers
  loc @ "_sweeper" getpropstr
  dup not if pop "None" .tell exit then
 
  (Fix sweeper list)
  stripmid
  STRIP
  "" "#" SUBST
  loc @ over "_sweeper" swap 0 ADDPROP
  getfirstref
  BEGIN
   dup #-2 dbcmp not while
   dup ok? not
   over player? not OR
   if
    loc @ swap "_sweeper" swap nextref swap
    loc @ swap "_sweeper" swap delref
   else
    loc @ swap "_sweeper" swap nextref
   then
  REPEAT
  pop
  (Show sweepers)
  loc @ "_sweeper" getpropstr
  getfirstref
  BEGIN
   dup #-2 dbcmp not while
   dup name .tell
   loc @ swap "_sweeper" swap nextref
  REPEAT
  pop
;
: alreadylisted?
  ref2 !
  0 temp2 !
  loc @ "_sweeper" getpropstr
  dup not if pop 0 exit then
  getfirstref
  BEGIN
   dup #-2 dbcmp not while
   dup ref2 @ dbcmp if 1 temp2 ! then
   loc @ swap "_sweeper" swap nextref
  REPEAT
  pop
  temp2 @
; 
: add-sweeper
  BEGIN
   "Enter the name of the player you want to authorize ('.' to abort)" .tell
   READ STRIP
   dup "." stringpfx 1 = if pop "Aborted." .tell exit then
   .pmatch
   dup #-1 dbcmp if pop "Not a valid player name." .tell continue then
   dup #-2 dbcmp if pop "I don't know who you mean." .tell continue then
   break
  REPEAT
  dup alreadylisted? if pop "This player is already authorized." .tell exit then
  loc @ "_sweeper" over over getpropstr " " strcat 4 rotate intostr strcat STRIP 0 ADDPROP
  "Player added." .tell
;
: remove-sweeper
  BEGIN
   "Enter the name of the player you want to remove ('.' to abort)" .tell
   READ STRIP
   dup "." stringpfx 1 = if pop "Aborted." .tell exit then
   .pmatch
   dup #-1 dbcmp if pop "Not a valid player name." .tell continue then
   dup #-2 dbcmp if pop "I don't know who you mean." .tell continue then
   dup alreadylisted? not if pop "This player is not listed." .tell continue then
   break
  REPEAT
  loc @ swap "_sweeper" swap delref
  "Player removed." .tell
;
: getdest
  loc @ "_swpdest" getpropstr
  dup not if pop "NONE!" exit then
  atoi dbref
  name
;
: getsucc
  loc @ "_swpsucc" getpropstr
  dup not
  if
   pop
   loc @ "_swpsucc" succdef 0 ADDPROP
   succdef
  then
;
: getosucc
  loc @ "_swposucc" getpropstr
  dup not
  if
   pop
   loc @ "_swposucc" osuccdef 0 ADDPROP
   "<sweeper> " osuccdef strcat
  else
   "<sweeper> " swap strcat
  then
;
: getvictim
  loc @ "_swpvictim" getpropstr
  dup not
  if
   pop
   loc @ "_swpvictim" victimdef 0 ADDPROP
   "<sweeper> " victimdef strcat
  else
   "<sweeper> " swap strcat
  then
;
: setup
  loc @ owner me @ dbcmp not if "Only the room owner can access the setup." .tell exit then
  BEGIN
   BEGIN
   " " .tell
   " " .tell
   " " .tell
   " BANSWEEP-SETUP     by Gyroplast  12/23/98" .tell
   "-------------------------------------------" .tell
   " " .tell
   "   [1] Room to sweep to: " getdest strcat .tell
   "   [2] Message shown to sweeper: " getsucc strcat .tell
   "   [3] Message shown to others: " getosucc strcat .tell
   "   [4] Message shown to swept player: " getvictim strcat .tell
   "   [5] Add/Remove authorized sweepers" .tell
   "   [0] QUIT" .tell
   " " .tell
   READ STRIP ATOI
   dup 0 < over 5 > OR if pop continue else BREAK then
   REPEAT
  dup not if pop "Setup finished." .tell exit then
  dup 1 = 
  if
   BEGIN
    " " .tell
    "Enter dbref of new destination, '.' to abort." .tell
    READ STRIP
    dup "." stringpfx 1 = if pop "Aborted." .tell break then
    ATOI DBREF
    dup ok? not if pop "Invalid dbref." .tell continue then
    dup room? over owner me @ dbcmp AND not 
    if
     pop
     "Invalid destination. You must specify a room you own." .tell
     continue
    then
    intostr
    loc @ swap "_swpdest" swap 0 ADDPROP
    break
   REPEAT
  then
 
  dup 2 =
  if
   " " .tell
   "Enter new message, space for default, '.' to abort." .tell
   READ STRIP
   dup "." stringpfx 1 = if pop "Aborted." .tell else
   loc @ swap "_swpsucc" swap 0 ADDPROP
  then then
 
  dup 3 =
  if
   " " .tell
   "Enter new message, space for default, '.' to abort." .tell
   READ STRIP
   dup "." stringpfx 1 = if pop "Aborted." .tell else
   loc @ swap "_swposucc" swap 0 ADDPROP
  then then
 
  dup 4 =
  if
   " " .tell
   "Enter new message, space for default, '.' to abort." .tell
   READ STRIP
   dup "." stringpfx 1 = if pop "Aborted." .tell else
   loc @ swap "_swpvictim" swap 0 ADDPROP
  then then
 
  5 =
  if
   BEGIN
    " " .tell
    "Authorized sweepers:" .tell
    list-sweepers
    " " .tell
    "Do you want to [a]dd or [r]emove a player? [q] to get back to the main menu." .tell
    READ STRIP
    dup "q" stringpfx 1 = if pop break then
    dup "r" stringpfx 1 = if pop remove-sweeper break then
    dup "a" stringpfx 1 = if pop add-sweeper break then
   REPEAT
  then
  REPEAT
;
: help
  " " .tell
  " BANSWEEP     by Gyroplast  12/23/98" .tell
  "-------------------------------------" .tell
  " " .tell
  "  #help         - Oh dear... " .tell
  "  #setup        - Runs the setup routine" .tell
  "  #check        - Checks for errors and corrects them automatically." .tell
  "  <player name> - Sweeps this player" .tell
  " " .tell
;
: check
  me @ loc @ owner dbcmp not if "Only the owner of the room may use this function." .tell exit then
  loc @ "_sweeper" over over over over getpropstr stripmid 0 ADDPROP
  getpropstr
  "Checking validity of properties in room " loc @ name strcat .tell
  "Checking _sweeper..." .tell
  dup not if "_sweeper is empty or does not exist." .tell else
  dup "#" instr
  if
   "'#' detected in _sweeper... fixing..."
   swap "" "#" SUBST swap "DONE" strcat .tell
  then
  loc @ over "_sweeper" swap 0 ADDPROP
  getfirstref
  BEGIN
   dup #-2 dbcmp not while
   dup ok? not
   over player? not OR
   if
    loc @ swap "_sweeper" swap nextref swap
    "Invalid dbref (#" over intostr strcat ") found." strcat
    swap loc @ over "_sweeper" swap delref
    " FIXED." strcat .tell
   else
    loc @ swap "_sweeper" swap nextref
   then
  REPEAT
  pop
  then
  (  _sweeper check complete  )
  "Authorization check complete." .tell
  "Now checking sweep messages..." .tell
  loc @ "_swpsucc" getpropstr
  not if
   "_swpsucc   does not exist. Using defaults." .tell
   loc @ "_swpsucc" succdef 0 ADDPROP
  then
 
  loc @ "_swposucc" getpropstr
  not if
   "_swposucc  does not exist. Using defaults." .tell
   loc @ "_swposucc" osuccdef 0 ADDPROP
  then
 
  loc @ "_swpvictim" getpropstr
  not if
   "_swpvictim does not exist. Using defaults." .tell
   loc @ "_swpvictim" victimdef 0 ADDPROP
  then
  "Message check complete." .tell
  "Checking sweep destination..." .tell
  loc @ "_swpdest" getpropstr
  dup not if pop "ERROR! _swpdest not set! Use #setup to correct this!" .tell exit then
  dup "#" instr
  if
   "'#' detected in _swpdest... fixing..."
   swap "" "#" SUBST swap "DONE" strcat .tell
  then
  loc @ over "_swpdest" swap 0 ADDPROP
  " " explode
  dup 1 >
  if
   "More than one dbref found. Deleting others..."
   loc @ "_swpdest" over over getpropstr getfirstref intostr 0 ADDPROP
   "DONE" strcat .tell
  then
  BEGIN
   swap pop
   1 - dup while
  REPEAT
  pop
  loc @ "_swpdest" getpropstr atoi dbref 
  dup room? not
  if
   "Invalid destination in _swpdest. #" swap intostr strcat " is not a room." strcat .tell
   exit
  then
  owner me @ dbcmp not
  if
   "Invalid destination in _swpdest. You do not own the room." .tell
   exit
  then
  "Check completed. No fatal errors were found." .tell
;
: validswpdest?
  loc @ "_swpdest" getpropstr atoi dbref
  dup room? swap owner loc @ owner dbcmp AND if 1 else 0 then
;
: main
  STRIP
  dup "#setup" stringcmp not if pop setup exit then
  dup "#help" stringcmp not over not OR if pop help exit then
  dup "#check" stringcmp not if pop check exit then
  match
  dup #-1 dbcmp if pop "This player is not here!" .tell exit then
  dup #-2 dbcmp if pop "I don't know who you mean!" .tell exit then
  dup player? not if pop "This is not a player!" .tell exit then
  dup loc @ owner dbcmp if pop "You cannot sweep the owner of a room!" .tell exit then
  dup me @ dbcmp if pop "You want to sweep yourself? Kinda silly, no?" .tell exit then
  loc @ "_sweeper" me @ nextref
  dup #-1 dbcmp
  swap #-3 dbcmp OR
  me @ loc @ owner dbcmp not AND
  if pop "You are not authorized to sweep here!" .tell exit then
  validswpdest? not if "_swpdest is not valid. Run #setup first." .tell exit then
  kick
;

