( safecall.muf  --  5/3/93  by Squirrelly )
(
    { xi ... x2 x1 d i -- }
    A "stack safe" way to call another program.
    Will call the given program [d], passing it [i] parameters,
    then return to the program calling this one, with [i] number
    of parameters removed from the stack and only that many, or
    else abort if it can't.
)
 
lvar XDEPTH
lvar XME
lvar XLOC
lvar XTRIGGER
lvar XCOMMAND
 
: safecall  ( xi ... x2 x1 d i -- )
    dup 0 < if
        "Invalid count passed." abort
        exit
    then
    2 + depth swap -
    dup 0 < if
        "Insufficient parameters on stack to make call." abort
        exit
    then
    XDEPTH !
    ME @ XME ! LOC @ XLOC ! TRIGGER @ XTRIGGER ! COMMAND @ XCOMMAND !
    call
    XME @ ME ! XLOC @ LOC ! XTRIGGER @ TRIGGER ! XCOMMAND @ COMMAND !
    begin
        depth XDEPTH @ > while
        pop
    repeat
    depth XDEPTH @ < if
        "Called program used too many parameters!" abort
        exit
    then
;

