: help
  "Feel.muf" .tell
  "--------------------------------------" .tell
  " " .tell
  " To set your feeling, type:" .tell
  " " .tell
  "   @set me=_feeling:<what others see when feeling you>" .tell
  " " .tell
  " If you want a custom notification message, change" .tell
  " " .tell
  "   @set me=_feel_notify:<whatever>" .tell
  " " .tell
  " If this property is cleared, the default \"+++++ %n just felt you!\"" .tell
  " will be used." .tell
  " MPI and pronoun substitutions are evaluated in both properties." .tell
  " " .tell
;
 
: feelnotify ( d d --  )
  over "_feel_notify" "{@desc}" 1 parseprop
  dup not if pop "+++++ %n just felt you!" then
  pronoun_sub notify
;
 
: feel ( d --  )
  dup me @ feelnotify
  dup "_feeling" "{@desc}" 1 parseprop
  dup not if pop "You feel nothing unusual." then
  pronoun_sub
;
 
: feelall ( d --  )
  contents
  BEGIN
    dup #-1 dbcmp not while
    dup "_feeling" getpropstr if
     dup name "[" swap strcat "]: " strcat over feel strcat .tell
    then
    next
  REPEAT
  pop
  "Done." .tell
;
 
: main
  dup "#h" stringpfx 1 = if pop help exit then
  dup not if me @ location feelall exit then
  match
  dup ok? not if pop "I don't see that here, or it's ambiguous." .tell exit then
  feel .tell
;

