( Auctionbank.muf     by Gyroplast   04/19/99
  
  For use with the auction.muf to give out credits to
  potential bidders. Only a certain amount is given out
  in a specified delay.
  SETUP:
    1. Create an action and link it to this program
    2. Type <action> #install to start setup
    3. Have phun!
  Permission to port is hereby granted. Questions, comments, flames or
  anything else go to gyroplast@yahoo.com or directly to me on
  FuzzyLogic. Please make only NECESSARY changes.
)
 
$def DEFCUR "auction dollars"
$def STORELOC trig "_storeloc" getpropstr atoi dup not if pop #-1 else dbref then
$def CURPROP "_currency"
$def CREDITS "_creds/"
$def TIMEPROP "_lastwithdraw/"
$def DELAYPROP "_delay"
$def MAXMONEY "_maxmoney"
$def MONEYGOT "_moneygot/"
 
: getlasttime (  -- i )
  STORELOC TIMEPROP me @ name strcat getpropstr atoi
;
 
: getmaxmoney (  -- i )
  trig location MAXMONEY getpropstr atoi
;
 
: getcurrency (  -- s )
  STORELOC CURPROP getpropstr dup not if pop DEFCUR then
;
 
: getdelay (  -- i )
  trig location DELAYPROP getpropstr atoi
;
 
: HowMuchLeft (  -- i )
  getmaxmoney STORELOC MONEYGOT me @ name strcat getpropstr atoi -
;
 
: mustwait? (  -- b )
  systime getlasttime - getdelay <
;
 
: WaitTime (  -- s )
  getdelay systime getlasttime - - ""
  over 86400 / dup not if
   pop
  else 
   intostr strcat " days, " strcat
   swap 86400 % swap
  then
  over 3600 / dup not if
   pop
  else
   intostr strcat " hours, " strcat
   swap 3600 % swap
  then
  over 60 / dup not if
   pop
  else
   intostr strcat " minutes and " strcat
   swap 60 % swap
  then
  swap intostr strcat " seconds" strcat
;
 
: CheckTime
  HowMuchLeft getmaxmoney = mustwait? not OR if
   STORELOC TIMEPROP me @ name strcat systime intostr 1 addprop
   STORELOC MONEYGOT me @ name strcat remove_prop
  then
;
 
: DoTransfer ( i --  )
  mustwait? HowMuchLeft not and if
   "Sorry, you have to wait " WaitTime strcat
   " before you can withdraw any more credits." strcat .tell pop exit
  then
  dup HowMuchLeft > if
   pop "You cannot withdraw more than " HowMuchLeft intostr strcat
   " " strcat getcurrency strcat "." strcat .tell exit
  then
  HowMuchLeft getmaxmoney = if
   STORELOC TIMEPROP me @ name strcat systime intostr 1 addprop
  then
  STORELOC MONEYGOT me @ name strcat getpropstr atoi over +
  STORELOC swap MONEYGOT me @ name strcat swap intostr 1 addprop
  STORELOC CREDITS me @ name strcat getpropstr atoi over +
  STORELOC swap CREDITS me @ name strcat swap intostr 1 addprop
  "You withdraw " swap intostr strcat " " strcat getcurrency strcat
  "." strcat .tell
;
 
: showhelp
  "Usage: " trig name strcat " <amount>" strcat .tell
;
 
: main
  CheckTime
  strip atoi
  dup not if pop showhelp exit then
  dup 0 <= if "You can only withdraw positive amounts." .tell pop exit then
  DoTransfer
;

